//+------------------------------------------------------------------+
//|                                                originally by cja |
//|                                          this version by mrtools |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

//
//
//
//
//

#property indicator_chart_window

//
//
//
//
//

extern int    Magic_num           = 12345;
extern int    Av_2                = 9;
extern int    Av_3                = 18;
extern int    Av_4                = 27;
extern int    Av_5                = 36;
extern int    Av_6                = 90;
extern color  Title_col           = DarkOrange;
extern color  Label_col           = Gray;
extern color  Av_col              = Red;
extern color  Total_col           = Silver;
extern color  Total_Av_col        = Red;
extern int    Shift_UP_DN         = 10;// Adjusts Signal Display Up & Down 
extern int    Adjust_Side_to_side = 10;// Adjusts Signal Display from side to side

extern string note                = "turn on Alert = true";
extern bool   alertsOn            = true;
extern bool   alertsOnCurrent     = true;
extern bool   alertsMessage       = true;
extern bool   alertsSound         = true;
extern bool   alertsEmail         = false;
extern string soundfile           = "alert2.wav";

//
//
//
//
//

double AV1[];
double RAvg[];
double buffer1[];

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
    IndicatorBuffers(3);
    SetIndexBuffer(0,AV1);
    SetIndexBuffer(1,RAvg);
    SetIndexBuffer(2,buffer1);
return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
//
//

int deinit()
{

   DeleteLabels();

return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{
    string symbol   = Symbol(); if (StringSubstr(symbol,0,2)=="_t") symbol = StringSubstr(symbol,2);
    double modifier = 1;
  	 int    digits   = MarketInfo(symbol,MODE_DIGITS);
    if (digits==3 || digits==5) modifier = 10.0;
  
    int counted_bars=IndicatorCounted();
    int i,y,limit;

    if(counted_bars<0) return(-1);
    if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
        
    //
    //
    //
    //
    //
    
    for (i=limit; i>=0; i--)
    {
  	
           AV1[i] = (iHigh(symbol,PERIOD_D1,i)  -iLow(symbol,PERIOD_D1,i))  /(MarketInfo(symbol,MODE_POINT)*modifier);
       int AV2    = (iHigh(symbol,PERIOD_D1,i+1)-iLow(symbol,PERIOD_D1,i+1))/(MarketInfo(symbol,MODE_POINT)*modifier);
   
       for(y=1;y<=Av_3;y++) int AV3 = AV3 + (iHigh(symbol,PERIOD_D1,y)-iLow(symbol,PERIOD_D1,y))/(MarketInfo(symbol,MODE_POINT)*modifier);
       for(y=1;y<=Av_4;y++) int AV4 = AV4 + (iHigh(symbol,PERIOD_D1,y)-iLow(symbol,PERIOD_D1,y))/(MarketInfo(symbol,MODE_POINT)*modifier);
       for(y=1;y<=Av_5;y++) int AV5 = AV5 + (iHigh(symbol,PERIOD_D1,y)-iLow(symbol,PERIOD_D1,y))/(MarketInfo(symbol,MODE_POINT)*modifier);
       for(y=1;y<=Av_6;y++) int AV6 = AV6 + (iHigh(symbol,PERIOD_D1,y)-iLow(symbol,PERIOD_D1,y))/(MarketInfo(symbol,MODE_POINT)*modifier);
       
       AV3     = AV3/Av_3;
       AV4     = AV4/Av_4;
       AV5     = AV5/Av_5;
       AV6     = AV6/Av_6;
       RAvg[i] = (AV2+AV3+AV4+AV5+AV6)/5;
      
       buffer1[i] = buffer1[i+1];
       if (AV1[i] >= RAvg[i]) buffer1[i] =  1;
       if (AV1[i] <  RAvg[i]) buffer1[i] = -1; 
       
       //
       //
       //
       //
       //
       
       double avg   = AV1[i]; 
       double r_avg = RAvg[i];
       
       CreateAverage("AV"+Magic_num,15+ Shift_UP_DN,10+ Adjust_Side_to_side);
       ObjectSetText("AV"+Magic_num,"Daily Range",9,"Arial Bold",DarkOrange); 
   
       CreateAverage("AV1"+Magic_num,28+ Shift_UP_DN,10+ Adjust_Side_to_side);
       ObjectSetText("AV1"+Magic_num,"-------------------------------",7,"Arial Bold",DarkSlateGray); 
   
   
       CreateAverage("AV2"+Magic_num,40+ Shift_UP_DN,60+ Adjust_Side_to_side );
       ObjectSetText("AV2"+Magic_num,"Today", 9,"Arial Bold",Gray); 
     
       CreateAverage("AV3"+Magic_num,40+ Shift_UP_DN,10+ Adjust_Side_to_side );
       ObjectSetText("AV3"+Magic_num,DoubleToStr(avg ,0), 9,"Arial Bold",Red); 
   
       CreateAverage("AV4"+Magic_num,60+ Shift_UP_DN,60+ Adjust_Side_to_side );
       ObjectSetText("AV4"+Magic_num,""+Av_2+" Days", 9,"Arial Bold",Gray); 
     
       CreateAverage("AV5"+Magic_num,60+ Shift_UP_DN,10+ Adjust_Side_to_side );
       ObjectSetText("AV5"+Magic_num,DoubleToStr(AV2 ,0), 9,"Arial Bold",Red); 
   
       CreateAverage("AV6"+Magic_num,80+ Shift_UP_DN,60+ Adjust_Side_to_side );
       ObjectSetText("AV6"+Magic_num,""+Av_3+" Days", 9,"Arial Bold",Gray); 
     
       CreateAverage("AV7"+Magic_num,80+ Shift_UP_DN,10+ Adjust_Side_to_side );
       ObjectSetText("AV7"+Magic_num,DoubleToStr(AV3 ,0), 9,"Arial Bold",Red); 
   
       CreateAverage("AV8"+Magic_num,100+ Shift_UP_DN,60+ Adjust_Side_to_side );
       ObjectSetText("AV8"+Magic_num,""+Av_4+" Days", 9,"Arial Bold",Gray); 
     
       CreateAverage("AV9"+Magic_num,100+ Shift_UP_DN,10+ Adjust_Side_to_side );
       ObjectSetText("AV9"+Magic_num,DoubleToStr(AV4 ,0), 9,"Arial Bold",Red); 
   
       CreateAverage("AV8"+Magic_num,100+ Shift_UP_DN,60+ Adjust_Side_to_side );
       ObjectSetText("AV8"+Magic_num,""+Av_4+" Days", 9,"Arial Bold",Gray); 
     
       CreateAverage("AV9"+Magic_num,100+ Shift_UP_DN,10+ Adjust_Side_to_side );
       ObjectSetText("AV9"+Magic_num,DoubleToStr(AV4 ,0), 9,"Arial Bold",Red); 
   
       CreateAverage("AV10"+Magic_num,120+ Shift_UP_DN,60+ Adjust_Side_to_side );
       ObjectSetText("AV10"+Magic_num,""+Av_5+" Days", 9,"Arial Bold",Gray); 
     
       CreateAverage("AV11"+Magic_num,120+ Shift_UP_DN,10+ Adjust_Side_to_side );
       ObjectSetText("AV11"+Magic_num,DoubleToStr(AV5 ,0), 9,"Arial Bold",Red); 
   
       CreateAverage("AV12"+Magic_num,140+ Shift_UP_DN,60+ Adjust_Side_to_side );
       ObjectSetText("AV12"+Magic_num,""+Av_6+" Days", 9,"Arial Bold",Gray); 
     
       CreateAverage("AV13"+Magic_num,140+ Shift_UP_DN,10+ Adjust_Side_to_side );
       ObjectSetText("AV13"+Magic_num,DoubleToStr(AV6 ,0), 9,"Arial Bold",Red); 
   
       CreateAverage("AV14"+Magic_num,167+ Shift_UP_DN,60+ Adjust_Side_to_side );
       ObjectSetText("AV14"+Magic_num,"Total Av", 9,"Arial Bold",Silver); 
  
       CreateAverage("AV15"+Magic_num,167+ Shift_UP_DN,10+ Adjust_Side_to_side );
       ObjectSetText("AV15"+Magic_num,DoubleToStr(r_avg ,0), 9,"Arial Bold",Red); 
   
       CreateAverage("AV16"+Magic_num,155+ Shift_UP_DN,10+ Adjust_Side_to_side );
       ObjectSetText("AV16"+Magic_num,"-------------------------------",7,"Arial Bold",DarkSlateGray); 
   
       CreateAverage("AV17"+Magic_num,180+ Shift_UP_DN,10+ Adjust_Side_to_side );
       ObjectSetText("AV17"+Magic_num,"-------------------------------",7,"Arial Bold",DarkSlateGray); 
       
       }
       
       //
       //
       //
       //
       //
       
       if (alertsOn)
       {
       if (alertsOnCurrent)
            int whichBar = 0;
       else     whichBar = 1;

       //
       //
       //
       //
       //
         
       if (buffer1[whichBar] != buffer1[whichBar+1])
       if (buffer1[whichBar] == 1)
             doAlert("more than Avg range");
       else  doAlert("less than Avg range");       
   } 
return(0);
}

//
//
//
//
//
 
int CreateAverage(string n, int Shift_UP_DN, int Adjust_Side_to_side) 
{
   ObjectCreate(n,OBJ_LABEL,0,0,0);
   ObjectSet(n,OBJPROP_CORNER,1);
   ObjectSet(n,OBJPROP_XDISTANCE,Adjust_Side_to_side);
   ObjectSet(n,OBJPROP_YDISTANCE,Shift_UP_DN);
   ObjectSet(n,OBJPROP_BACK, false);
}

//
//
//
//
//
   
void DeleteLabels()
{
   
    ObjectDelete("AV"+Magic_num);   ObjectDelete("AV1"+Magic_num);  ObjectDelete("AV2"+Magic_num);
    ObjectDelete("AV3"+Magic_num);  ObjectDelete("AV4"+Magic_num);  ObjectDelete("AV5"+Magic_num);
    ObjectDelete("AV6"+Magic_num);  ObjectDelete("AV7"+Magic_num);  ObjectDelete("AV8"+Magic_num);
    ObjectDelete("AV9"+Magic_num);  ObjectDelete("AV10"+Magic_num); ObjectDelete("AV11"+Magic_num);
    ObjectDelete("AV12"+Magic_num); ObjectDelete("AV13"+Magic_num); ObjectDelete("AV14"+Magic_num);
    ObjectDelete("AV15"+Magic_num); ObjectDelete("AV16"+Magic_num); ObjectDelete("AV17"+Magic_num);
}
   
//+------------------------------------------------------------------+
//
//
//
//
//+------------------------------------------------------------------+

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Average Range ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Average Range "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

